'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Log = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _logger = require('./logger');

var _level = require('./level');

var _display = require('./display');

var _include = require('./include');

var _helper = require('./helper');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

if (_helper.Helpers.isNode) {}

var Log = exports.Log = function () {
    function Log() {
        _classCallCheck(this, Log);
    }

    _createClass(Log, null, [{
        key: 'create',
        value: function create(name) {
            var i = void 0;
            if (Log.instances[name] === undefined) {
                for (var _len = arguments.length, level = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                    level[_key - 1] = arguments[_key];
                }

                i = new _logger.Logger(name, Log.getRandomColor(), Log.isDevelopmentMode, level, Log.isMutedModule(name), Log.levels.length > 0 ? Log.fixedWidth : undefined);
                Log.instances[name] = i;
            } else {
                i = Log.instances[name];
            }
            return i;
        }
    }, {
        key: 'getRandomColor',
        value: function getRandomColor() {
            if (_helper.Helpers.isNode) {}
            var letters = '012345'.split('');
            var color = '#';
            color += letters[Math.round(Math.random() * 5)];
            letters = '0123456789ABCDEF'.split('');
            for (var i = 0; i < 5; i++) {
                color += letters[Math.round(Math.random() * 15)];
            }
            if (color === undefined) return this.getRandomColor();
            return color;
        }
    }, {
        key: 'display',
        value: function display(name, data, incomming, moduleName) {
            if (!(0, _include.contain)(Log.levels, incomming)) return;
            if (incomming === _level.Level.DATA) {
                _display.Display.msg(name, data, moduleName, Log.instances[moduleName].color, _level.Level.DATA, Log.instances[moduleName].fixedWidth);
            }
            if (incomming === _level.Level.ERROR) {
                _display.Display.msg(name, data, moduleName, Log.instances[moduleName].color, _level.Level.ERROR, Log.instances[moduleName].fixedWidth);
            }
            if (incomming === _level.Level.INFO) {
                _display.Display.msg(name, data, moduleName, Log.instances[moduleName].color, _level.Level.INFO, Log.instances[moduleName].fixedWidth);
            }
            if (incomming === _level.Level.WARN) {
                _display.Display.msg(name, data, moduleName, Log.instances[moduleName].color, _level.Level.WARN, Log.instances[moduleName].fixedWidth);
            }
        }
    }, {
        key: 'onlyLevel',
        value: function onlyLevel() {
            if (Log._logOnly) {
                throw '[ng2-logger] You should use funcion onlyLevel only once';
            }
            if (!Log._logOnly) {
                Log._logOnly = true;
            }

            for (var _len2 = arguments.length, level = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                level[_key2] = arguments[_key2];
            }

            Log.levels = Array.isArray(level) ? level : [level];
            for (var logName in Log.instances) {
                if (Log.instances.hasOwnProperty(logName)) {
                    var element = Log.instances[logName];
                    element['allowed'] = Log.levels;
                }
            }
        }
    }, {
        key: 'onlyModules',
        value: function onlyModules() {
            if (Log._logModules) {
                throw '[ng2-logger] You should use funcion onlyModules only once';
            }
            if (!Log._logModules) {
                Log._logModules = true;
            }

            for (var _len3 = arguments.length, modules = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                modules[_key3] = arguments[_key3];
            }

            if (modules.length === 0) return;
            Log.modules = modules;
            // console.log('only log this', Log.modules)
            Log.muteAllOtherModules();
        }
    }, {
        key: 'isMutedModule',
        value: function isMutedModule(moduleName) {
            if (Log.modules.length == 0) return false;
            if (!(0, _include.contain)(Log.modules, moduleName)) return true;
            return false;
        }
    }, {
        key: 'muteAllOtherModules',
        value: function muteAllOtherModules() {
            for (var moduleName in Log.instances) {
                if (!(0, _include.contain)(Log.modules, moduleName)) Log.instances[moduleName].mute();
            }
        }
    }, {
        key: 'setProductionMode',
        value: function setProductionMode() {
            if (Log.modeIsSet) {
                Log.modeIsSet = false;
                throw '[ng2-logger] Production mode is already set';
            } else {
                Log.modeIsSet = true;
                setTimeout(function () {
                    if (Log.modeIsSet && console !== undefined && console.clear !== undefined) {
                        console.clear();
                        console.log = function () {};
                        console.error = function () {};
                        console.warn = function () {};
                        console.info = function () {};
                    }
                });
                _logger.Logger.isProductionMode = true;
                Log.isDevelopmentMode = false;
            }
        }
    }]);

    return Log;
}();

Log.instances = {};
Log.fixedWidth = 0;
Log._logOnly = false;
Log.levels = [];
Log._logModules = false;
Log.modules = [];
Log.isDevelopmentMode = true;
Log.modeIsSet = false;
//# sourceMappingURL=log.js.map